/** \file
 * 
 * Sep 4, 2013
 *
 * Copyright Ian Kaplan 2013
 *
 * @author Ian Kaplan, www.bearcave.com, iank@bearcave.com
 */
package t9.trie;

/**
 * <p>
 * Pair - a container for a String (word) and its relative frequency within the top 5K
 *        english words.
 * </p>
 *        
 * Sep 3, 2013
 * 
 * @author Ian Kaplan, iank@bearcave.com
 */
public class Pair implements Comparable<Pair> {
    final String word;
    final int frequency;

    @SuppressWarnings("javadoc")
    public Pair(String word, int frequency) {
        this.word = word;
        this.frequency = frequency;
    }
    @Override
    public int compareTo(Pair obj) {
        int rslt = this.word.compareTo(obj.word);
        return rslt;
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((word == null) ? 0 : word.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        Pair other = (Pair) obj;
        if (word == null) {
            if (other.word != null)
                return false;
        } else if (!word.equals(other.word))
            return false;
        return true;
    }

} // class Pair