/** \file
 * 
 * Sep 2, 2013
 *
 * Copyright Ian Kaplan 2013
 *
 * @author Ian Kaplan, www.bearcave.com, iank@bearcave.com
 */
package t9.trie;

import java.util.Comparator;


/**
 * TrieNode
 * Sep 3, 2013
 * 
 * The frequency value is only set for the character that ends the string.
 * 
 * @author Ian Kaplan, iank@bearcave.com
 */
public class TrieNode {
    private final char mLetter;
    private boolean eow;  // end of word
    private TrieNode mChild;
    private TrieNode mSib;
    private int mFrequency;
    
    public TrieNode getChild() {
        return mChild;
    }

    public void setChild(TrieNode child) {
        this.mChild = child;
    }

    public TrieNode getSib() {
        return mSib;
    }

    public void setSib(TrieNode sib) {
        this.mSib = sib;
    }

    public char getLetter() {
        return mLetter;
    }

    public int getFrequency() {
        return mFrequency;
    }

    public void setFrequency(int frequency) {
        this.mFrequency = frequency;
    }

    public TrieNode(final char letter) {
        this.mLetter = letter;
        this.mChild = null;
        this.mSib = null;
        eow = false;
        mFrequency = -1;
    }

    public void setEOW() {
        eow = true;
    }
    
    public boolean isEOW() {
        return eow;
    }

}
